using UnityEngine;
using System.Collections;

public class MusicManager : MonoBehaviour 
{
	public AudioSource introSequence;
	public AudioSource mainSequence;
	public bool persistent = false;
	
	private bool mainPlaySwitch = false;

	// Use this for initialization
	void Start () 
	{
		MusicManager [] music_managers = FindObjectsOfType(typeof(MusicManager)) as MusicManager[];
		
		if(music_managers.Length <= 1)
		{
		
			introSequence.Play();
			
			if(persistent)
			{
				DontDestroyOnLoad(gameObject);
				
				foreach(Transform child in transform)
				{
					DontDestroyOnLoad(child.gameObject);
				}
			}
		}
		else
		{
			foreach(Transform child in transform)
			{
				Destroy(child.gameObject);
			}
			Destroy(gameObject);
		}
		
	
	}
	
	// Update is called once per frame
	void FixedUpdate () 
	{
		if(!introSequence.isPlaying && ! mainSequence.isPlaying && !mainPlaySwitch)
		{
			
			introSequence.Stop();
			mainSequence.Play();
			mainPlaySwitch = true;
		}
	}
}
