using UnityEngine;
using System.Collections;

public class Blink2Mat : MonoBehaviour 
{
	public float blinkInterval = 0.5f;
	public float flashPeriod = 0.2f;
	public bool loop = true;
	public Material flashMaterial;
	public Material defaultMaterial;
	
	private float blinkClock = 0;
	private float flashClock = 0;
	
	
	//UNITY CALLBACK FUNCTIONS
	// Use this for initialization
	void Start () 
	{
		
	}
	
	// Update is called once per frame
	void Update () 
	{
		if(blinkClock != null && defaultMaterial != null && renderer != null)
		{
			if(flashClock > 0)
			{
				renderer.material = flashMaterial;
				flashClock -=  Time.deltaTime;
			}
			else
			{
				renderer.material = defaultMaterial;
			}
			
			if(blinkClock > 0)
			{
				blinkClock -= Time.deltaTime;
			}
			else
			{
				if(loop)
				{
					blinkClock = blinkInterval;
					flashClock = flashPeriod;
				}
			}
		}
	
	}
	//UNITY CALLBACK FUNCTIONS
	
	public void Flash()
	{
		flashClock = flashPeriod;
	}
}
