using UnityEngine;
using System.Collections;

/*BounceBlaster Project
CameraClickMove.cs

Matt's basic way of click-panning.

Authors:
1) Matt Cabanag
2) ..
3) ..

*/

public class CameraClickMove : MonoBehaviour 
{
	public float raycastLength = 100;
	public LayerMask qBrickMask = 8;
	
	private bool moveMode = false;
	private Vector3 mouseDown = Vector3.zero;
	
	// Use this for initialization
	void Start () 
	{

	}
	
	// Update is called once per frame
	void Update () 
	{
		Ray moveRay = Camera.main.ScreenPointToRay(Input.mousePosition);
		
		RaycastHit moveRayHit;
		
		
		if(Input.GetMouseButtonDown(0))
		{
			mouseDown = moveRay.GetPoint(raycastLength);
			
			//only move if you're not clicking on a qBrick
			if(!Physics.Raycast(moveRay,out moveRayHit,raycastLength + 50,qBrickMask.value))
			{
				Debug.Log("Didn't hit a QBrick. Allow movement.");
				moveMode = true;
			}
			else
			{
				Debug.Log("Did hit a QBrick. Disallow movement.");
				moveMode = false;
			}
		}
		
		//move when the mouse didn't first land on a qbrick
		if(Input.GetMouseButton(0))
		{
			if(moveMode)
			{
				if(mouseDown != Vector3.zero)
				{
					transform.position += (mouseDown - moveRay.GetPoint(raycastLength));
				}
			}
		}
		
		//disable movement after every button release
		if(Input.GetMouseButtonUp(0) || Input.GetMouseButtonUp(1))
		{
			moveMode = false;
		}
	}
}
