using UnityEngine;
using System.Collections;

public class CameraOrbit : MonoBehaviour 
{
	
	public Transform target;
	public float distance;
	public float scrollWheelMultiplier = 600;
	
	public float xSpeed = 250.0f;
	public float ySpeed = 120.0f;
	
	public float distanceMin = 20;
	public float distanceMax = 120;
	public float yMinLimit = 20;
	public float yMaxLimit = 80;
	
	private float x = 0.0f;
	private float y = 0.0f;
	
	void OnDrawGizmosSelected()
	{
		y = 45.0f;
		LateUpdate();	
	}
	
	// Use this for initialization
	void Start () 
	{
		if(rigidbody != null)
		{
			rigidbody.freezeRotation = true; 
		}
		
		//Vector3 angles = transform.eulerAngles;
		x = 0.0f;
		y = 45.0f;
	}
	
	void LateUpdate () 
	{
		if(target != null)
		{
			
			if(Input.GetMouseButton(2))
			{
				x += Input.GetAxis("Mouse X") * xSpeed * 0.02f;
	        	y -= Input.GetAxis("Mouse Y") * ySpeed * 0.02f;
				
			}
			y = ClampAngle(y, yMinLimit, yMaxLimit);
			distance = Mathf.Clamp(distance,distanceMin,distanceMax);
				
			Quaternion rotation = Quaternion.Euler(y, x, 0f);
        	Vector3 position = (rotation * new Vector3(0.0f, 0.0f, -distance)) + target.position;
			
			transform.rotation = rotation;
       		transform.position = position;
			
			float zoomMultiplier,camZoom;
			
			zoomMultiplier = Vector3.Distance(transform.position,target.transform.position); 
			
			if(zoomMultiplier > 10)
			{
				zoomMultiplier = 50;
			}
			
			if(zoomMultiplier < 1)
			{
				zoomMultiplier = 1;
			}
			
			distance -= Input.GetAxis("Mouse ScrollWheel")*zoomMultiplier;
		}
	}
	
	static float ClampAngle (float angle, float min, float max) 
	{
		if (angle < -360)
			angle += 360;
		if (angle > 360)
			angle -= 360;
		return Mathf.Clamp(angle, min, max);
	}
}
