using UnityEngine;
using System.Collections;

public class FadeinInfo : MonoBehaviour 
{
	
	public string playerTag = "Team0";
	public float displayProximity = 15.0f;
	public float fadeInRate = 0.85f;
	public float fadeOutRate = 0.25f;
	public Renderer textRenderer;
	public bool mouseMode = false;
	public GameObject remoteFadeinObj;

	
	private float alpha = 0.0f;
	private Transform qacTransform;
	private bool inTrigger = false;
	

	// Use this for initialization
	void Start () 
	{
		qacTransform = transform;	

	}
	
	void AlphaChildren(Transform root, Color col1, Color col2)
	{
		
		//float r = renderer.material.color.r;
		//float g = renderer.material.color.g;
		//float b = renderer.material.color.b;
		
		
		root.gameObject.active = true;
		
		foreach(Transform child in root)	
		{
			child.gameObject.active = true;
			
			if(child.renderer != null)
			{
				string childName = child.name.ToLower();
				//Debug.Log(childName);
				if(!childName.Contains("translucent"))
				{	
					child.renderer.material.color = col1;
				}
				else
				{
					child.renderer.material.color = col2;
				}
			}
			
			AlphaChildren(child,col1,col2);
		}
	}
	
	// Update is called once per frame
	void Update () 
	{	
		float r,g,b;
		
		if(renderer != null)
		{
		 	r = renderer.material.color.r;
			g = renderer.material.color.g;
			b = renderer.material.color.b;
			renderer.material.color =  new Color(r,g,b,alpha*0.75f);
		}
		else
		{
			r = 1;
			g = 1;
			b = 1;
		}
		
		Color curCol = new Color(r,g,b,alpha*0.75f);		
		Color bgCol = new Color(r,g,b,alpha*0.35f);
		
		if(remoteFadeinObj == null)
		{
			if(textRenderer != null)
			{
				textRenderer.material.color =  curCol;
				AlphaChildren(transform,curCol,bgCol);
			}
		}
		else
		{
			if(remoteFadeinObj.renderer != null)
			{
				remoteFadeinObj.renderer.material.color = curCol;
			}
			AlphaChildren(remoteFadeinObj.transform,curCol,bgCol);
		}
		
		
		if(inTrigger)
		{
			if(alpha < 1.0f)
			{
				alpha += fadeInRate * Time.deltaTime;
			}
			else
			{
				alpha = 1.0f;
			}
		}
		else
		{
			if(alpha > 0.0f)
			{
				alpha -= fadeOutRate * Time.deltaTime;
			}
			else
			{
				alpha = 0.0f;
			}
			
		}
	}
	
	void OnTriggerEnter(Collider other) 
	{
		//Debug.Log("OnTriggerEnter");
        if(other.tag  == playerTag)
		{
			inTrigger = true;
		}
    }
	
	void OnTriggerStay(Collider other) 
	{
		//Debug.Log("OnTriggerStay");
        if(other.tag  == playerTag)
		{
			inTrigger = true;
		}
    }
	
	void OnTriggerExit(Collider other)
	{
		//Debug.Log("OnTriggerExit");
		if(other.tag  == playerTag)
		{
			inTrigger = false;
		}
	}
	
	void OnMouseEnter()
	{
		if(mouseMode)
		{
			inTrigger = true;
		}
	}
	
	void OnMouseExit()
	{
		if(mouseMode)
		{
			inTrigger = false;
		}
	}
	
}
