using UnityEngine;
using System.Collections;

public class FadeoutAuto : MonoBehaviour 
{
	public float fadestartDelay = 2.5f;
	public float fadeOutRate = 0.25f;
	
	private float alpha = 1.0f;
	private Transform qacTransform;
	private float fadeClock = 0;
	

	// Use this for initialization
	void Start () 
	{
		qacTransform = transform;
		fadeClock = fadestartDelay;
		
		if(renderer != null)
		{
			renderer.enabled = true;
		}
	}
	
	// Update is called once per frame
	void Update () 
	{
	
		float r,g,b;
		
		if(renderer != null)
		{
		 	r = renderer.material.color.r;
			g = renderer.material.color.g;
			b = renderer.material.color.b;
			renderer.material.color =  new Color(r,g,b,alpha*0.75f);
		}
		else
		{
			r = 1;
			g = 1;
			b = 1;
		}
		
		if(fadeClock <= 0)
		{
			if(alpha > 0)
			{
				alpha -= fadeOutRate * Time.deltaTime;
			}
			else
			{
				alpha = 0.0f;
			}
		}
		else
		{
			fadeClock -= Time.deltaTime;
		}
		Color curCol = new Color(r,g,b,alpha);	
		
		if(renderer != null)
		{
			renderer.material.color = curCol;
		}
		
		AlphaChildren(qacTransform,curCol,curCol);
	}
	
	void AlphaChildren(Transform root, Color col1, Color col2)
	{
		
		//float r = renderer.material.color.r;
		//float g = renderer.material.color.g;
		//float b = renderer.material.color.b;


		root.gameObject.SetActive(true);	

		foreach(Transform child in root)	
		{
			child.gameObject.active = true;
			
			if(child.renderer != null)
			{
				string childName = child.name.ToLower();
				//Debug.Log(childName);
				if(!childName.Contains("translucent"))
				{	
					child.renderer.material.color = col1;
				}
				else
				{
					child.renderer.material.color = col2;
				}
			}
			
			AlphaChildren(child,col1,col2);
		}
	}

}
