using UnityEngine;
using System.Collections;

public class HealthBar : MonoBehaviour 
{
	public float maxLength = 2.0f;
	public float yScale = 0.25f;
	
	public KeyCode showBarKey = KeyCode.LeftAlt;
	public Killable subject;
	public MeshRenderer outline;
	
	private Transform qacTransform;
	private float debugXscale = 0;
	private float debugHealth;
	private float debugMaxHealth;
	private MeshRenderer qacRenderer;
	private bool showBarToggle = true;
	
	
	// Use this for initialization
	void Start () 
	{
		qacTransform = transform;
		qacRenderer = GetComponent<MeshRenderer>();
	}
	
	// Update is called once per frame
	void Update () 
	{
		if(subject != null)
		{
			float newXscale = (maxLength) * ((float)subject.health/(float)subject.maxHealth);
			
			debugXscale = newXscale;
			debugHealth = (float)subject.health;
			debugMaxHealth = (float)subject.maxHealth;
			
			float oldYscale = qacTransform.localScale.y;
			float oldZscale = qacTransform.localScale.z;
			
			qacTransform.localScale = new Vector3(newXscale,yScale,yScale);
			
		}
		
		if(qacRenderer != null)
		{
			
			if(Input.GetKeyDown(showBarKey))
			{
				if(!showBarToggle)
				{
					showBarToggle = true;
				}
				else
				{
					showBarToggle = false;
				}
			}
			
			if(showBarToggle)
			{
				qacRenderer.enabled = true;
				
				if(outline != null)
				{
					outline.enabled = true;
				}
			}
			else
			{
				qacRenderer.enabled = false;
				
				if(outline != null)
				{
					outline.enabled = false;
				}
			}
		}
	}
}
