using UnityEngine;
using System.Collections;

public class HugTerrain : MonoBehaviour 
{
	public LayerMask terrainMask = 9;
	public float raycastLength = 100;
	
	private Transform qacTransform;

	// Use this for initialization
	void Start () 
	{
	
		qacTransform = transform;
	}
	
	void OnAwake()
	{
		qacTransform = transform;
		HugFloor();
	}
	
	void OnDrawGizmosSelected()
	{
		qacTransform = transform;
		HugFloor();
	}
	
	// Update is called once per frame
	void Update () 
	{
		HugFloor();
	}
	
	void HugFloor()
	{
		Ray groundRay = new Ray();
		
		groundRay = new Ray(transform.position + new Vector3(0,raycastLength/2,0),Vector3.down);
		
		RaycastHit groundHit;
		
		if(Physics.Raycast(groundRay,out groundHit,raycastLength,terrainMask.value))
		{
			//hug the floor
			transform.position = groundHit.point;
		}
	}
}
