using UnityEngine;
using System.Collections;

public class Killable : MonoBehaviour 
{
	public int health = 10;
	public int maxHealth = 10;
	public bool killable = true;
	public GameObject hitFX;
	public GameObject deathFX;
	public GameObject [] deathSpawnList;
	
	public TextMesh healthText;
	
	private AudioSource qacAudio;
	
	// Use this for initialization
	void Start () 
	{
		qacAudio = audio;
	}
	
	void OnDisable()
	{

	}
	
	// Update is called once per frame
	void Update () 
	{
		if(health > maxHealth)
		{
			health = maxHealth;
		}
		
		if(health <= 0)
		{
			
			if(deathFX != null)
			{
				GameObject newHit = (GameObject)Instantiate(deathFX,transform.position,transform.rotation);
			}
			
			foreach(GameObject ds in deathSpawnList)
			{
				GameObject d = (GameObject)Instantiate(ds,transform.position,transform.rotation);
				d.tag = tag;
			}
			
			Destroy(gameObject);
		}
		
		if(healthText != null)
		{
			healthText.text = health.ToString();
		}
	}
	
	public void Kill()
	{
		health = 0;
	}
	
	public void Damage(int damage)
	{
		health -= damage;
		
		if(hitFX != null)
		{
			GameObject newHit = (GameObject)Instantiate(hitFX,transform.position,transform.rotation);
		}
	}
}
