using UnityEngine;
using System.Collections;

public class NoChildTrigger : MonoBehaviour 
{
	//this component will activate a specified game object
	//if all of it's own children have disappeared.

	public GameObject triggerObject;
	
	private Transform qacTransform;
	private bool activeSwitch = false;
	
	// Use this for initialization
	void Start () 
	{
		qacTransform = transform;
		
		if(triggerObject != null)
		{
			triggerObject.active = false;
			
			foreach(Transform child in triggerObject.transform)
			{
				child.gameObject.active = false;
			}
		}
	
	}
	
	// Update is called once per frame
	void Update () 
	{
	
		if(triggerObject != null && !activeSwitch)
		{
			if(qacTransform.childCount == 0)
			{
				if(triggerObject != null)
				{
					triggerObject.active = true;
					activeSwitch = true;
					
					foreach(Transform child in triggerObject.transform)
					{
						child.gameObject.active = true;
					}
				}
			}
		}
	}
}
