using UnityEngine;
using System.Collections;

/*
BounceBlaster Project
TextMeshPropagateText.cs
Syncs up the text in a TextMesh tree

Fakes the zoom-in/out effect for an orthographic camera.

Authors:
1) Matt Cabanag
2) ..
3) ..

*/


public class TextMeshPropagateText : MonoBehaviour 
{
	public bool autoSync = true;
	
	private TextMesh qacTextMesh;

	// Use this for initialization
	void Start () 
	{
		qacTextMesh = GetComponent<TextMesh>();
		SyncText(qacTextMesh);
		
	}
	
	void OnDrawGizmosSelected()
	{
		SyncText(qacTextMesh);
	}
	
	// Update is called once per frame
	void Update () 
	{
		if(autoSync)
		{
			SyncText();
		}
	}
	
	public void SyncText()
	{
		SyncText(qacTextMesh);
	}
	
	void SyncText(TextMesh scd)
	{
		if(scd != null)
		{
			foreach(Transform child in scd.transform)
			{
				TextMesh cscd = child.GetComponent<TextMesh>();
				cscd.text = scd.text;
				cscd.fontSize = scd.fontSize;
				if(cscd != null)
				{
					SyncText(cscd);
				}
			}
		}
	}
}
