using UnityEngine;
using System.Collections;

public class WASDPan : MonoBehaviour 
{
	public float panSpeed = 3;
	public bool relativeToCamera = true;
	
	private Transform qacTransform;

	// Use this for initialization
	void Start () 
	{
		qacTransform = transform;
	}
	
	// Update is called once per frame
	void Update () 
	{
		CheckInput();
	}
	
	void CheckInput()
	{
		Vector3 delta = new Vector3();
		
		/*
		if(Input.GetKey(KeyCode.W))
		{
			qacTransform.Translate(0,0,ySpeed*Time.deltaTime);
		}
		
		if(Input.GetKey(KeyCode.S))
		{
			qacTransform.Translate(0,0,-ySpeed*Time.deltaTime);
		}
		
		if(Input.GetKey(KeyCode.A))
		{
			qacTransform.Translate(-xSpeed*Time.deltaTime,0,0);
		}
		
		if(Input.GetKey(KeyCode.D))
		{
			qacTransform.Translate(xSpeed*Time.deltaTime,0,0);
		}
		*/
		
		//North, East, West, South movement
		if(Input.GetKey("w"))
		{
			//qacTransform.Translate(0,0,ySpeed*Time.deltaTime);
			delta += new Vector3(0,0,panSpeed);
		}
		
		if(Input.GetKey("s"))
		{
			//qacTransform.Translate(0,0,-ySpeed*Time.deltaTime);
			delta += new Vector3(0,0,-panSpeed);
		}
		
		if(Input.GetKey("a"))
		{
			//qacTransform.Translate(-xSpeed*Time.deltaTime,0,0);
			delta += new Vector3(-panSpeed,0,0);
		}
		
		if(Input.GetKey("d"))
		{
			//qacTransform.Translate(xSpeed*Time.deltaTime,0,0);
			delta += new Vector3(panSpeed,0,0);
		}
		

		//make sure the WASD action is relative to the camera
		
		if(relativeToCamera)
		{
			Vector3 camPos = Camera.mainCamera.transform.position;
			Quaternion camRot = Camera.mainCamera.transform.rotation;
			//delta = qacTransform.rotation * delta;
			transform.rotation = new Quaternion(0,camRot.y,0,camRot.w);
		}
		
		
		qacTransform.Translate(delta*Time.deltaTime);
	}
}
