using UnityEngine;
using System.Collections;

public class OxygenEndscreen : MonoBehaviour 
{
	public TextMesh txtDisplay;
	public Timer timer;
	
	private int totalCount = 0;
	private int tagCount = 0;
	private int deadCount = 0;
	private int liveCount = 0;
	
	private bool tallySwitch = false;
	
	// Use this for initialization
	void Start () 
	{
	
	}
	
	// Update is called once per frame
	void Update () 
	{
		if(txtDisplay != null)
		{
			TallyScore();
			string yourStatus = "Alive";
			
			if(timer.activeObj == null)
			{
				yourStatus = "Dead";	
			}
			
			txtDisplay.text = "END OF GAME RESULTS \n\n";
			txtDisplay.text += "Time Remaining: " + timer.timer + "\n";
			txtDisplay.text += "Initial Survivors: " + totalCount + "\n";
			txtDisplay.text += "Your Status: " + yourStatus + "\n";
			txtDisplay.text += "Tagged: " + tagCount + "\n";
			txtDisplay.text += "Alive: " + liveCount + "\n";
			txtDisplay.text += "Dead: " + deadCount + "\n";
			
			
			
		}
	}
	
	void TallyScore()
	{
		if(!tallySwitch)
		{
			SignalBeacon [] finalBeaconList = FindObjectsOfType(typeof(SignalBeacon)) as SignalBeacon [];
			
			totalCount = finalBeaconList.Length;
			
			foreach(SignalBeacon s in finalBeaconList)
			{
				if(s.TagStatus())
				{
					tagCount++;
				}
				
				if(s.active)
				{
					liveCount++;
				}
				else
				{
					deadCount++;
				}
				
				s.active = false;
			}
			tallySwitch = true;
		}
	}
}
