using UnityEngine;
using System.Collections;

public class OxygenProbeDisplay : MonoBehaviour 
{
	public TextMesh txtItemStatus;
	public OxygenProbe myProbe;
	
	//UNITY CALLBACKS
	// Use this for initialization
	void Start () 
	{
	
	}
	
	// Update is called once per frame
	void Update () 
	{
		txtItemStatus.text = "";
		if(myProbe != null)
		{
			if(myProbe.GetMyTarget() != null)
			{
				EnableChildren(transform);
				
				txtItemStatus.text = "==[SCAN DATA]==========\n";
				
				if(myProbe.GetMyTarget().isAlive())
				{
					txtItemStatus.text += "life signs: ACTIVE \n"; 
				}
				else
				{
					txtItemStatus.text += "life signs: NEGATIVE \n";
				}
				
				txtItemStatus.text += "oxygen: " + myProbe.GetMyTarget().GetOxygenLevels().ToString("#00.00") + "\n";
				
				if(myProbe.GetMyTarget().name != "")
				{
					txtItemStatus.text += "name: "+ myProbe.GetMyTarget().name + "\n";
				}
				
				if(myProbe.GetMyTarget().sex != "")
				{
					txtItemStatus.text += "sex: "+ myProbe.GetMyTarget().sex + "\n";
				}
				
				if(myProbe.GetMyTarget().age != "")
				{
					txtItemStatus.text += "age: "+ myProbe.GetMyTarget().age + "\n";
				}
				
				if(myProbe.GetMyTarget().position != "")
				{
					txtItemStatus.text += "position: " + myProbe.GetMyTarget().position + "\n";
				}
				
				if(myProbe.GetMyTarget().crime != "")
				{
					txtItemStatus.text += "crime: "+ myProbe.GetMyTarget().crime + "\n";
				}
			}
			else
			{
				DisableChildren(transform);
			}
		}
	}
	//UNITY CALLBACKS
	
	void DisableChildren(Transform root)
	{
		foreach(Transform child in root)
		{
			child.gameObject.SetActive(false);
			DisableChildren(child);
		}
	}
	
	void EnableChildren(Transform root)
	{
		foreach(Transform child in root)
		{
			child.gameObject.SetActive(true);
			EnableChildren(child);
		}
	}
}
