using UnityEngine;
using System.Collections;

public class OxygenRandomSpawner : MonoBehaviour 
{
	public float xSpread;
	public float ySpread;
	
	public GameObject tankPrefab;
	public GameObject personPrefab;
	
	public int minTankCount;
	public int maxTankCount;
	public int minPersonCount;
	public int maxPersonCount;
	public int minAge;
	public int maxAge;
	public string [] firstnamesMale;
	public string [] firstnamesFemale;
	public string [] lastnames;
	public string [] positions;
	public string [] crimes;

	// Use this for initialization
	void Start () 
	{
		RandomSpawn();
	}
	
	// Update is called once per frame
	void Update () 
	{
	
	}
	
	void RandomSpawn()
	{
		
		int tankCount = (int) Random.Range (minTankCount,maxTankCount);
		int personCount = (int) Random.Range (minPersonCount,maxPersonCount);
		
		if(tankPrefab != null)
		{
			//spawn the tanks
			for(int i = 0; i < tankCount; i++)
			{
				Vector3 spawnPos = transform.position 
					+ new Vector3(Random.Range(-xSpread/2,xSpread/2),transform.position.y,Random.Range(-ySpread/2,ySpread/2));
				GameObject t = (GameObject) Instantiate (tankPrefab,spawnPos,transform.rotation);
			}
		}
		
		if(personPrefab != null)
		{
			//spawn the people
			for(int i = 0; i < tankCount; i++)
			{
				Vector3 spawnPos = transform.position 
					+ new Vector3(Random.Range(-xSpread/2,xSpread/2),transform.position.y,Random.Range(-ySpread/2,ySpread/2));
				GameObject p = (GameObject) Instantiate (personPrefab,spawnPos,transform.rotation);
				OxygenCharacter oc = p.GetComponent<OxygenCharacter>();
	
				
				oc.age = Random.Range(minAge,maxAge).ToString ("#00");
				
				if(firstnamesFemale.Length > 0 && firstnamesMale.Length > 0 && lastnames.Length > 0)
				{
					string fn;
					
					if(Random.Range(0,10) > 5)
					{
						fn = firstnamesMale[(int)Random.Range (0, firstnamesMale.Length -1)];
						oc.sex = "M";
					}
					else
					{
						fn = firstnamesFemale[(int)Random.Range (0, firstnamesFemale.Length -1)];
						oc.sex = "F";
					}
					
					string ln = lastnames[(int)Random.Range (0, lastnames.Length -1)];
					oc.name = fn + " " + ln;
				}
				
				if(positions.Length > 0)
				{
					oc.position = positions[(int)Random.Range (0, positions.Length -1)];
				}
				
				//string position = oc.position;
				
				if(crimes.Length > 0 && oc.position.ToLower().Contains("inmate"))
				{
					oc.crime = crimes[(int)Random.Range (0, crimes.Length -1)];
				}
				else
				{
					oc.crime = "";
				}
			}
		}
	}
}
