using UnityEngine;
using System.Collections;

public class TeleportTrail : MonoBehaviour 
{
	public Transform origin;
	public Transform destination;
	public float speed = 10;
	public float startDelay = 0.25f;
	public float startInterval = 0.25f;
	public int extraTrails = 5;
	
	// Use this for initialization
	void Start () 
	{
		if(origin == null)
		{
			origin = transform;
		}
		
		if(extraTrails > 0)
		{
			extraTrails--;
			
			GameObject newTT = (GameObject) Instantiate(gameObject,transform.position,transform.rotation);
			
			TeleportTrail tt = newTT.GetComponent<TeleportTrail>();
			tt.extraTrails = extraTrails;
			tt.startDelay = startDelay + startInterval;
		}
		
	}
	
	// Update is called once per frame
	void Update () 
	{
		if(startDelay <= 0)
		{
			if(origin != null && destination != null)
			{
				//move to your destination
				Vector3 newPos = Vector3.MoveTowards(transform.position,destination.position,Time.deltaTime*speed);
				transform.position = newPos;
				
				//disappear when you get there!
				float dist2dest = Vector3.Distance(origin.position,destination.position);
				
				if(dist2dest < speed*Time.deltaTime)
				{
					Destroy(gameObject);
				}
				
			}
			else
			{
				Destroy(gameObject);
			}
		}
		else
		{
			startDelay -= Time.deltaTime;
		}
	}
}

